# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
$search = $ldap->search(base=>'xyz.com',
                        scope=>'subtree',
                        filter=>'(&(objectclass=user)(objectcategory=Person))');
die $search->error if $search->code;
print "Total entries returned: ",$search->count,"\n";
print $entry->get_value('cn'),"\n" foreach $entry $search->entries;
