'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim Container as IADsContainer
Set Namespaces = GetObject("LDAP://cn=Users,dc=xyz,dc=com")
'If you perform an enumeration without a filter, you return objects of all classes - users, groups, etc.
'Adding a Filter, you can tailor the result set to objects of the specified class(es):
Container.Filter = Array("User")
For Each User in Container
         Debug.Print User.ADsPath
Next
