# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use Win32::OLE;
eval {
   $wmi_path = "winmgmts://dc1/root/directory/LDAP:RootDSE=@";
   $rootDSE = Win32::OLE->GetObject($wmi_path)
      or die "Could not get RootDSE\n";
   print "dnsHostname:          $rootDSE->{dnsHostName}\n";
   print "defaultNamingContext: $rootDSE->{defaultNamingContext}\n";
};
if ($@) {
   print "Error: $@\nOLE Error: ",Win32::OLE->LastError, "\n";
}
