VERSION 5.00
Begin VB.Form frmNetJoin 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "NetJoinDomain"
   ClientHeight    =   4155
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4710
   Icon            =   "Chap06_Listing01_Net_Join_Domain_form.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4155
   ScaleWidth      =   4710
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdJoin 
      Caption         =   "&Join"
      Height          =   375
      Left            =   1560
      TabIndex        =   10
      Top             =   3720
      Width           =   1575
   End
   Begin VB.Frame Frame1 
      Height          =   3615
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4695
      Begin VB.TextBox txtOU 
         Height          =   285
         Left            =   240
         TabIndex        =   11
         Top             =   1920
         Width           =   4215
      End
      Begin VB.ListBox lstOutput 
         Height          =   840
         Left            =   240
         TabIndex        =   5
         Top             =   2520
         Width           =   4215
      End
      Begin VB.TextBox txtPasswd 
         Height          =   285
         IMEMode         =   3  'DISABLE
         Left            =   2520
         PasswordChar    =   "*"
         TabIndex        =   4
         Top             =   1320
         Width           =   1935
      End
      Begin VB.TextBox txtUserid 
         Height          =   285
         Left            =   2520
         TabIndex        =   3
         Top             =   960
         Width           =   1935
      End
      Begin VB.TextBox txtDomain 
         Height          =   285
         Left            =   2520
         TabIndex        =   2
         Top             =   600
         Width           =   1935
      End
      Begin VB.TextBox txtHost 
         Height          =   285
         Left            =   2520
         TabIndex        =   1
         Top             =   240
         Width           =   1935
      End
      Begin VB.Label Label6 
         Alignment       =   1  'Right Justify
         Caption         =   "Output:"
         Height          =   255
         Left            =   240
         TabIndex        =   13
         Top             =   2280
         Width           =   615
      End
      Begin VB.Label Label5 
         Alignment       =   1  'Right Justify
         Caption         =   "Organizational Unit (Optional):"
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   1680
         Width           =   2295
      End
      Begin VB.Label Label4 
         Alignment       =   1  'Right Justify
         Caption         =   "Administrative Password:"
         Height          =   255
         Left            =   480
         TabIndex        =   9
         Top             =   1320
         Width           =   1935
      End
      Begin VB.Label Label3 
         Alignment       =   1  'Right Justify
         Caption         =   "Administrative Account:"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   960
         Width           =   2175
      End
      Begin VB.Label Label2 
         Alignment       =   1  'Right Justify
         Caption         =   "Target Domain Name:"
         Height          =   255
         Left            =   360
         TabIndex        =   7
         Top             =   600
         Width           =   2055
      End
      Begin VB.Label Label1 
         Alignment       =   1  'Right Justify
         Caption         =   "Target Host (Blank for Local):"
         Height          =   255
         Left            =   240
         TabIndex        =   6
         Top             =   240
         Width           =   2175
      End
   End
End
Attribute VB_Name = "frmNetJoin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

' -----------------------------------------------------------------------------
' From the book "Managing Enterprise Active Directory Services"
' ISBN: 0-672-32125-4
' Copyright (C) 2002 by Addison-Wesley
' Code by Richard Puckett
'
' You have a royalty-free right to use, modify, reproduce and distribute
' this code (and/or any modified version) in any way you find useful,
' with the agreement that Richard Puckett or Addison-Wesley provide no
' warranty, obligations or liability for this code. If you reuse or
' modify this code, you must retain this copyright notice.
' -----------------------------------------------------------------------------

' WARNING: While this API will join a host to a Domain, it will not reset the appropriate
' registry values on the target host, nor will it add the appropriate default Global
' groups into the target hosts local groups.  These will also have to be managed
' programmatically as part of any planned join function.  Also, this API, when used
' inproperly, can result in a system being left in an unstable state.  Be sure to have
' a local Administrative account handy to perform local logons in the event of failure.


Private Const NETSETUP_JOIN_DOMAIN = &H1
Private Const NETSETUP_ACCT_CREATE = &H2
Private Const NETSETUP_DOMAIN_JOIN_IF_JOINED = &H20
Private Const NETSETUP_JOIN_UNSECURE = &H40

Private Declare Function NetJoinDomain Lib "Netapi32.dll" _
        (ByVal lpServer As Long, _
        ByVal lpDomain As Long, _
        ByVal lpAccountOU As Long, _
        ByVal lpAccount As Long, _
        ByVal lpPassword As Long, _
        ByVal fJoinOptions As Long) As Long

Private Sub Form_Load()

    txtHost.Text = "TARGET_HOSTNAME"
    txtDomain.Text = "ADC-XYZ-201\XYZ"
    txtUserid.Text = "XYZ\Administrator"
    txtPasswd.Text = "password"
    txtOU.Text = "OU=XYZ Computers,DC=amer,DC=xyz,DC=com"
    
End Sub

Private Sub cmdJoin_Click()


    lstOutput.Clear


    Dim lRet As Long
    
    lRet = JoinDomain(txtHost.Text, _
           txtOU.Text, _
           txtDomain.Text, _
           txtUserid.Text, _
           txtPasswd.Text)

End Sub

Private Function JoinDomain(Machine As String, OU As String, Domain As String, _
    Account As String, Password As String) As Long
    
    Dim lRet As Long
    Dim Msg As String
    Dim lptrOrU As Long
    Dim lptrDom As Long
    Dim lptrAct As Long
    Dim lptrPwd As Long
    Dim lptrMac As Long
    Dim dwFlags As Long
    
    dwFlags = NETSETUP_JOIN_DOMAIN + NETSETUP_ACCT_CREATE

    lptrDom = StrPtr(Domain)
    
    If LenB(Machine) = 0 Then
        lptrMac = 0&
    Else
        lptrMac = StrPtr(Machine)
    End If
    
    If LenB(Account) = 0 Then
        lptrAct = 0&
    Else
        lptrAct = StrPtr(Account)
    End If
    If LenB(Password) = 0 Then
        lptrPwd = 0&
    Else
        lptrPwd = StrPtr(Password)
    End If
    If LenB(OU) = 0 Then
        lptrOrU = 0&
    Else
        lptrOrU = StrPtr(OU)
    End If
    
    lRet = NetJoinDomain(lptrMac, _
           lptrDom, _
           lptrOrU, _
           lptrAct, _
           lptrPwd, _
           dwFlags)

    If lRet <> 0 Then
        Select Case lRet
            Case 87&
                Msg = "Error " & lRet & _
                ": a passed parameter is incorrect."
            Case 1355&
                Msg = "Error " & lRet & _
                ": The specified Domain name (" & Domain & ") was not found."
            Case 1787&
                Msg = "Error " & lRet & _
                ": A computer account was not found for " & Machine & "."
            Case 2691&
                Msg = "Error " & lRet & _
                ": This computer is already joined to the " & Domain & " Domain"
            Case 2695&
                Msg = "Error " & lRet & _
                ": The specified Domain name (" & Domain & ") is not valid."
            Case Else
                Msg = "Error " & lRet & _
                ": An unspecified error has occurred."
        End Select
        lstOutput.AddItem Msg
    Else
        lstOutput.AddItem "Successfully added " & Machine & " to the " & Domain & " Domain"
    End If
    
    JoinDomain = lRet

End Function

