'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
ON ERROR RESUME NEXT

Dim user, passwd, server
server = "dc1"
user   = "administrator@xyz.com"
passwd = "password"

' Get domain naming context
Dim rootDSE
set rootDSE = GetObject("LDAP://" & server & "/RootDSE")
Dim adsPath
adsPath =  "LDAP://" & server & "/" & _
               rootDSE.Get("defaultNamingContext") & ""
Dim ldapObj, domainObj
Set ldapObj = GetObject("LDAP:")
' Get domain object
Set domainObj = ldapObj.OpenDsObject(adsPath,user,passwd,1)
Dim ouObj
Set ouObj = domainObj.Create("organizationalUnit","OU=Employees")
ouObj.Put "description", "OU for XYZ Employee user accounts"
ouObj.SetInfo
If Err.Number then
   Wscript.Echo "Error occurred when creating OU: " & Err.Description
Else
   Wscript.Echo "OU Created"
End If
