'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
ON ERROR RESUME NEXT

Dim server, user, passwd
server = "dc1"
user = "administrator@xyz.com"
passwd = "password"

' Update the becomePDC operational attribute
Dim ldapObj, rootDSE
Set ldapObj = GetObject("LDAP:")
' Requires a bind to the RootDSE
Set rootDSE = ldapObj.OpenDsObject("LDAP://" & server & "/RootDSE", _
                                   user, passwd, 1)
rootDSE.Put "becomePDC", 1
rootDSE.SetInfo

If Err.Number then
    Wscript.Echo "Could not transfer FSMO: " _
                 & Err.Description
Else
   Wscript.Echo  "Successfully initiated FSMO transfer to " & server
End If
