'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim old_site, old_site_dn, user, passwd, server, siteObj, ldapObj

old_site = "RTP"

server = "dc1.xyz.com"
user   = "administrator@xyz.com"
passwd = "password"

' This could be dynamically computed using RootDSE
old_site_dn = "cn=" & old_site & ",cn=sites,cn=configuration,dc=xyz,dc=com"

Set ldapObj  = GetObject("LDAP:")
Set siteObj = ldapObj.OpenDsObject("LDAP://" & server & "/" & old_site_dn, _
                                    user, passwd, 1)
Wscript.Echo "Deleting site container for " & old_site
siteObj.DeleteObject(0)
Wscript.Echo "Site deletion complete"
