'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim user, passwd, server, ldapObj, serverObj, dc, new_site, old_site
Dim sites_dn, new_serversCont_dn, old_servers_dn

' Move information
dc       = "dc2"
new_site = "RTP"
old_site = "Default-First-Site-Name"
sites_dn = "cn=sites,cn=configuration,dc=xyz,dc=com"

' Bind information
server = "dc1.xyz.com"
user   = "administrator@xyz.com"
passwd = "password"

Set ldapObj = GetObject("LDAP:")
new_serversCont_dn = "cn=Servers,cn=" & new_site & "," & sites_dn
Set serverObj = ldapObj.OpenDsObject("LDAP://" & server & "/" & _
                                     new_serversCont_dn, user, passwd, 1)
old_servers_dn = "LDAP://" & server & "/cn=" & dc & ",cn=Servers,cn=" & _
                  old_site & "," & sites_dn

Wscript.Echo "Moving server " & dc
serverObj.MoveHere old_servers_dn, "cn=" & dc
Wscript.Echo "Server move complete"
