'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim user, passwd, server, absSchemaObj, attrObj, ldapObj, count

server = "dc1"
user   = "administrator@xyz.com"
passwd = "password"

Set ldapObj = GetObject("LDAP:")
Set absSchemaObj = ldapObj.OpenDsObject("LDAP://" & server & "/Schema", _
                                        user, passwd, 1)
absSchemaObj.Filter = Array("Property")
count = 0
For Each attrObj in absSchemaObj
   If attrObj.MultiValued = True Then
      Wscript.Echo attrObj.Name
      count = count + 1
   End If
Next
wscript.Echo "Count: " & count
