'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim strUser, strPasswd
strUser   = "administrator@xyz.com"
strPasswd = "password"

ADS_GROUP_TYPE_DOMAIN_LOCAL_GROUP = 1
ADS_GROUP_TYPE_GLOBAL_GROUP       = 2
ADS_GROUP_TYPE_LOCAL_GROUP        = 4
ADS_GROUP_TYPE_SECURITY_ENABLED   = -2147483648
ADS_GROUP_TYPE_UNIVERSAL_GROUP    = 8

Dim ldapObj, groupADsPath, groupObj
Set ldapObj = GetObject("LDAP:")

contADsPath = "LDAP://cn=Users,dc=xyz,dc=com"
Set contObj = ldapObj.OpenDsObject(contADsPath,strUser,strPasswd,1)

new_group = "NewGroup"
Set grpObj = contObj.Create("group","cn=" & new_group)
grpObj.Description = new_group
grpObj.Put "sAMAccountName", new_group
grpObj.Put "groupType", ADS_GROUP_TYPE_UNIVERSAL_GROUP _ 
                          Or ADS_GROUP_TYPE_SECURITY_ENABLED
grpObj.SetInfo
