'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim strPrinter, strPrintServer
strPrinter = "bldg2-floor2-printer"
strPrintServer = "print-bldg2"

Dim strUser,strPasswd, strADsPath
strADsPath = "LDAP://OU=printers,dc=xyz,dc=com"
strUser = "administrator@xyz.com"
strPasswd = "password"

Dim ldapObj, domainObj
Set ldapObj = GetObject("LDAP:")
Set domainObj = ldapObj.OpenDsObject(strADsPath,strUser,strPasswd,1)

Dim printObj
Set printObj = domainObj.Create("printQueue","cn=" & strPrinter)
printObj.Put "uNCName", "\\" & strPrintServer & "\" & strPrinter
printObj.Put "serverName", strPrintServer
printObj.Put "shortServerName",strPrintServer
printObj.Put "printerName", strPrinter
printObj.Put "versionNumber", "1"
printObj.Put "location", "HQ"
printObj.Put "driverName", "HP 5si"
printObj.Put "printColor", TRUE
printObj.Put "printDuplexSupported", TRUE
printObj.Put "printStaplingSupported", FALSE
printObj.SetInfo
