'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim compObj,pqObj,pjObj
Set compObj = GetObject("WinNT://print-rtp-ew")
compObj.Filter = Array("PrintQueue")
For Each pqObj In compObj
   Wscript.Echo "Print Queue: " & pqObj.Name
   Dim count
   count = 0
   For Each pjObj In pqObj.PrintJobs
      Wscript.Echo "  Job:"
      Wscript.Echo "   Description: " & pjObj.Description
      Wscript.Echo "   User: " & pjObj.User
      Wscript.Echo "   Submitted: " & pjObj.TimeSubmitted
      Wscript.Echo "   Size: " & pjObj.Size
      Wscript.Echo "   Elapsed: " & pjObj.TimeElapsed
      Wscript.Echo "   Status: " & pjObj.Status
      Wscript.Echo "   Position: " & pjObj.Position
      Wscript.Echo "   Printed: " & pjObj.PagesPrinted
      count = count + 1
   Next
   Wscript.Echo "  Total jobs in queue: " & count
Next
