# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use Win32::OLE;
my $RootDSE = Win32::OLE->GetObject("LDAP://RootDSE");
my $UserContainer = Win32::OLE->GetObject("LDAP://cn=Users," .
                                         $RootDSE->Get("defaultNamingContext") );
$UserContainer->{Filter} = ['User'];
foreach my $User( in $UserContainer) {
    print $User->ADsPath,"\n";
}
