'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim RootDSE as IADs
Set RootDSE = GetObject("LDAP://RootDSE")
Dim UserContainer as IADsContainer
Dim User as IADsUser
Set UserContainer = GetObject("LDAP://cn=Users," & 
RootDSE.Get("defaultNamingContext"))
UserContainer.Filter = Array("User")
For Each User in UserContainer
    Debug.Print User.ADsPath
Next
