'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim DSO as IADsOpenDSObject
Set DSO = GetObject('LDAP:')
Dim User as IADsUser
Set User = DSO.OpenDSObject('LDAP://cn=jdoe,ou=New York,ou=Americas,' & _
ou=Users,dc=xyz,dc=com','administrator@xyz.com','password',0)
Here is the same example in Perl:
use Win32::OLE;
my $DSO = Win32::OLE->GetObject('LDAP:');
my $User = $DSO->OpenDSObject('LDAP://cn=jdoe,ou=New York, ou=Americas,' .
                                                'ou=Users,dc=xyz,dc=com',
                              'administrator@xyz.com',
                              'password',
                              0);
