# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use Win32::OLE;
eval {
   $wmi_path = 'winmgmts:root/directory/LDAP';
   $users = Win32::OLE->GetObject($wmi_path)->InstancesOf("ds_user")
      or die "Could not get users\n";
   foreach $user(in $users) {
      print $user->{'ds_samaccountname'},"\n";
   }
};
if ($@) {
   print "Error: $@\nOLE Error: ",Win32::OLE->LastError, "\n";
}
