'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
On Error Resume Next
Dim wmi_path, wql_query
wmi_path = "winmgmts:{(security)}"
wql_query =  " select * " & _
             "   from __instancecreationevent" & _
             "  where targetinstance isa 'Win32_NTLogEvent'" & _
             "    and targetinstance.LogFile = 'System'" & _
             "    and targetinstance.EventIdentifier = 5778 "
set events = GetObject(wmi_path).ExecNotificationQuery(wql_query)
if err <> 0 then
   WScript.Echo Err.Description, Err.Number, Err.Source
end if

WScript.Echo ""
WScript.Echo "Waiting for NT Event..."
WScript.Echo ""

do
   set NTEvent = events.NextEvent   if err <> 0 then
      WScript.Echo Err.Number, Err.Description, Err.Source
      Exit Do
   else
      WScript.Echo "Log:     " & NTEvent.TargetInstance.LogFile
      WScript.Echo "EventID: " & NTEvent.TargetInstance.EventIdentifier
      WScript.Echo "Message: " & NTEvent.TargetInstance.Message
      WScript.Echo "Time:    " & NTEvent.TargetInstance.TimeGenerated
      WScript.Echo ""
   end if
loop
