'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
ON ERROR RESUME NEXT

Dim ADsPath, user, passwd, server
server = "dc1"
user   = "administrator@xyz.com"
passwd = "password"

Dim rootDSE
Set rootDSE = GetObject("LDAP://" & server & "/RootDSE")
ADsPath =  "LDAP://" & server & "/" & "cn=Partitions," _
              & rootDSE.Get("ConfigurationNamingContext")
Dim ldapObj
Set ldapObj = GetObject("LDAP:")
Dim partObj
Set partObj = ldapObj.OpenDsObject(ADsPath,user,passwd,1)
partObj.GetInfo
partObj.PutEx 3, "uPNSuffixes", Array("test.com")
partObj.SetInfo
If Err.Number then
    Wscript.Echo "Could not update upnsuffixes: " _
                 & Err.Description
Else
    Wscript.Echo "Successfully updated upnsuffixes"
End If
