VERSION 5.00
Begin VB.Form repl 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "DReplicaGetInfo"
   ClientHeight    =   5430
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   6255
   Icon            =   "Chap09_Listing20_DS_Get_Repl_Info_form.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5430
   ScaleWidth      =   6255
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Height          =   5415
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   6255
      Begin VB.CommandButton cmdGetRepl 
         Caption         =   "&Get Replica Info"
         Height          =   375
         Left            =   1320
         TabIndex        =   4
         Top             =   4920
         Width           =   1695
      End
      Begin VB.ListBox lstOutput 
         Height          =   4545
         Left            =   120
         TabIndex        =   3
         Top             =   240
         Width           =   6015
      End
      Begin VB.CommandButton cmdCopy 
         Caption         =   "&Copy to Clipboard"
         Height          =   375
         Left            =   3240
         TabIndex        =   2
         Top             =   4920
         Width           =   1695
      End
      Begin VB.TextBox txtCopy 
         Height          =   375
         Left            =   5400
         TabIndex        =   1
         Top             =   4920
         Visible         =   0   'False
         Width           =   495
      End
   End
End
Attribute VB_Name = "repl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit
Option Base 0

' -----------------------------------------------------------------------------
' From the book "Managing Enterprise Active Directory Services"
' ISBN: 0-672-32125-4
' Copyright (C) 2002 by Addison-Wesley
' Code by Richard Puckett
'
' You have a royalty-free right to use, modify, reproduce and distribute
' this code (and/or any modified version) in any way you find useful,
' with the agreement that Richard Puckett or Addison-Wesley provide no
' warranty, obligations or liability for this code. If you reuse or
' modify this code, you must retain this copyright notice.
' -----------------------------------------------------------------------------

Private Const GUID_LENGTH As Long = 40

'typedef enum _DS_REPL_INFO_TYPE{
Private Const DS_REPL_INFO_NEIGHBORS = 0&
Private Const DS_REPL_INFO_CURSORS_FOR_NC = 1&
Private Const DS_REPL_INFO_METADATA_FOR_OBJ = 2&
Private Const DS_REPL_INFO_KCC_DSA_CONNECT_FAILURES = 3&
Private Const DS_REPL_INFO_KCC_DSA_LINK_FAILURES = 4&
Private Const DS_REPL_INFO_PENDING_OPS = 5&
'} DS_REPL_INFO_TYPE;

Private Type LARGE_INTEGER
    lowpart As Long
    highpart As Long
End Type

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

'typedef struct _GUID{
'  unsigned long  Data1;
'  unsigned short Data2;
'  unsigned short Data3;
'  unsigned char  Data4[8];
'} GUID;
'typedef GUID UUID;

Private Type GUID
   Data1 As Long
   Data2 As Integer
   Data3 As Integer
   Data4(0 To 7) As Byte
End Type

'typedef struct _DS_REPL_ATTR_META_DATA {
'  LPTSTR pszAttributeName;
'  DWORD dwVersion;
'  FILETIME ftimeLastOriginatingChange;
'  UUID uuidLastOriginatingDsaInvocationID;
'  USN usnOriginatingChange;
'  USN usnLocalChange;
'} DS_REPL_ATTR_META_DATA;

Private Type DS_REPL_ATTR_META_DATA
    pszAttributeName As Long
    dwVersion As Long
    ftimeLastOrigChange As FILETIME
    uuidLastOriginatingDsaInvocationID As GUID
    usnOriginatingChange As Currency
    usnLocalChange As Currency
End Type

'typedef struct _DS_REPL_OBJ_META_DATA {
'  DWORD cNumEntries;
'  DWORD dwReserved;
'  DS_REPL_ATTR_META_DATA rgMetaData[];
'} DS_REPL_OBJ_META_DATA;

Private Type DS_REPL_OBJ_META_DATA
    cNumEntries As Long
    dwReserved As Long
    rgMetaData(0 To 200) As DS_REPL_ATTR_META_DATA
End Type

'VOID DsReplicaFreeInfo(
'  DS_REPL_INFO_TYPE InfoType,
'  VOID* pInfo
');

Private Declare Function FileTimeToLocalFileTime Lib "kernel32.dll" _
   (lpFileTime As FILETIME, _
   lpLocalFileTime As FILETIME) As Long
     
Private Declare Function FileTimeToSystemTime Lib "kernel32.dll" _
   (lpFileTime As FILETIME, _
   lpSystemTime As SYSTEMTIME) As Long
   
Private Declare Function lstrlenW Lib "kernel32.dll" _
    (ByVal lpString As Long) As Long

Private Declare Function DsReplicaGetInfo Lib "Ntdsapi.dll" _
    Alias "DsReplicaGetInfoW" _
    (ByVal hDS As Long, _
    ByVal InfoType As Long, _
    ByVal pszObject As Long, _
    ByVal pUuid As Long, _
    ppInfo As Long) As Long

Private Declare Function StringFromGUID2 Lib "ole32.dll" _
    (pGuid As GUID, _
    ByVal PointerToString As Long, _
    ByVal MaxLength As Long) As Long

Private Declare Function DsReplicaFreeInfo Lib "Ntdsapi.dll" _
    (ByVal InfoType As Long, _
    ByVal pInfo As Long) As Long

Private Declare Function DsMakePasswordCredentials Lib "Ntdsapi.dll" _
    Alias "DsMakePasswordCredentialsA" _
    (ByVal User As String, _
    ByVal Domain As String, _
    ByVal Password As String, _
    pAuthIdentity As Long) As Long

Private Declare Function DsBindWithCred Lib "Ntdsapi.dll" _
    Alias "DsBindWithCredA" _
    (ByVal DomainController As String, _
    ByVal DnsDomainName As String, _
    ByVal AuthIdentity As Long, _
    phDS As Long) As Long
    
Private Declare Function DsFreePasswordCredentials Lib "Ntdsapi.dll" _
    (ByVal AuthIdentity As Long) As Long
    
Private Declare Function DsBind Lib "Ntdsapi.dll" _
    Alias "DsBindA" _
    (ByVal DomainController As String, _
    ByVal DnsDomainName As String, _
    phDS As Long) As Long
    
Private Declare Function DsUnBind Lib "Ntdsapi.dll" _
    Alias "DsUnBindA" _
    (ByVal phDS As Long) As Long
   
Private Declare Sub MoveMemory Lib "kernel32.dll" _
    Alias "RtlMoveMemory" _
    (pDest As Any, _
    pSource As Any, _
    ByVal dwLength As Long)

Private Sub Form_Load()

End Sub

Private Sub cmdGetRepl_Click()

    Dim lngRet As Long
    Dim Userid As String
    Dim Passwd As String
    Dim Domain As String
    Dim strSrch As String
    Dim ADC As String
    
    Userid = "userid"
    Passwd = "password"
    Domain = "XYZ"
    ADC = "adc-xyz-201.amer.xyz.com"
    strSrch = "cn=rpuckett,ou=employees,ou=xyz users,dc=amer,dc=xyz,dc=com" & Chr$(0)
        
    lngRet = GetReplData(Userid, Passwd, Domain, ADC, strSrch)
    
    If lngRet <> 0 Then
        MsgBox "Error " & lngRet
    Else
        MsgBox "Success!"
    End If

End Sub

Private Function GetReplData(strUserid As String, strPasswd As String, _
    StrDomain As String, StrDC As String, pszObj As String) As Long

    Dim lRet As Long
    Dim hDS As Long
    Dim hCred As Long
    Dim strADC As String
    Dim i As Long
    Dim lPtr As Long
    Dim strRet As String
    Dim strDate As String
    Dim pUuid As GUID
    Dim sTime As SYSTEMTIME
    Dim fTime As FILETIME
    Dim lNum As LARGE_INTEGER
    Dim pReplObj As DS_REPL_OBJ_META_DATA
    Dim pAttrObj As DS_REPL_ATTR_META_DATA
    
    strADC = "\\" & StrDC & Chr(0)
    
    ' Create a credential handle
    lRet = DsMakePasswordCredentials(strUserid, _
           StrDomain, _
           strPasswd, _
           hCred)

    If lRet <> 0 Then
        Debug.Print "Error " & lRet & " creating a credential handle for " & _
        StrDomain & "\" & strUserid
        GoTo hError
    Else
        Debug.Print "Successfully created a credential handle for " & _
        StrDomain & "\" & strUserid
    End If
    
    ' Bind to a Domain Controller
    lRet = DsBindWithCred(strADC, _
           vbNullString, _
           hCred, _
           hDS)
    
    If lRet <> 0 Then
        Debug.Print "Error " & lRet & " binding to " & _
        StrDC & " with the credential handle"
        GoTo hError
    Else
        Debug.Print "Successfully bound to " & _
        StrDC & " with the credential handle"
    End If
        
    ' use DsBind handle to retrieve data, since VB stores strings in ANSI, use
    ' StrPtr to point to unicode version of the passed in string
    lRet = DsReplicaGetInfo(hDS, _
           DS_REPL_INFO_METADATA_FOR_OBJ, _
           StrPtr(pszObj), _
           0&, _
           lPtr)
    
    If lRet <> 0 Then
        lstOutput.AddItem "Error " & lRet & " retrieving Replica info for " & pszObj
        GetReplData = lRet
        Exit Function
    Else
        lstOutput.AddItem "Successfully retrieved Replica info"
        
        ' pointer to DS_REPL_OBJ_META_DATA, copy into struct
        MoveMemory pReplObj, ByVal lPtr, Len(pReplObj)
        
        With pReplObj
            lstOutput.AddItem "Number of attributes returned: " & .cNumEntries
            lstOutput.AddItem " "
            
            ' every other entry is populated, so double the
            ' loop value returned in .cNumEntries
            For i = 0 To .cNumEntries
                With .rgMetaData(i)
    
                    ' pointer to unicode string, covert to ansi & display
                    strRet = PtrToStrW(.pszAttributeName)
                    If LenB(strRet) > 0 Then
                        lstOutput.AddItem "Index: " & i
                        lstOutput.AddItem "Attribute Name: " & strRet
                        lstOutput.AddItem "Version: " & .dwVersion
                        
                        ' pointer to FILETIME struct, copied and
                        ' converted to localtime, then systemtime
                        MoveMemory fTime, .ftimeLastOrigChange, Len(fTime)
                        FileTimeToLocalFileTime fTime, fTime
                        FileTimeToSystemTime fTime, sTime
                        strDate = sTime.wMonth & "-" & sTime.wDay & "-" & sTime.wYear & _
                                  " " & sTime.wHour & ":" & sTime.wMinute & ":" & sTime.wSecond
                        
                        lstOutput.AddItem "Time Last Change: " & Format(strDate, "mm-dd-yyyy hh:nn:ss")
                        
                        ' use the returned pointer to copy the data into the GUID/UUID
                        ' struct this in turn can be used to lookup the servername
                        MoveMemory pUuid, .uuidLastOriginatingDsaInvocationID, Len(pUuid)
                        lstOutput.AddItem "Originating Invocation UUID: " & GetStrGUID(pUuid)
                        
                        ' USN data appears to be a 64-bit integer...
                        lstOutput.AddItem "USN Local Change: " & .usnLocalChange * 10000
                        lstOutput.AddItem "USN Originating Change: " & .usnOriginatingChange * 10000
                        lstOutput.AddItem " "
                    End If
                
                End With
            
            Next i
        
        End With
    
    End If
    
    ' Free the pointer to the array of structs
    DsReplicaFreeInfo DS_REPL_INFO_METADATA_FOR_OBJ, lPtr
    
    ' Free the passed in Credentials
    lRet = DsFreePasswordCredentials(hCred)
    
    If lRet <> 0 Then
        Debug.Print "Error " & lRet & " freeing the credential handle"
        GoTo hError
    Else
        Debug.Print "Successfully freed the credential handle"
    End If
    
    ' Unbind from the server
    lRet = DsUnBind(hDS)
    
    If lRet <> 0 Then
        Debug.Print "Error " & lRet & " unbinding from the Domain"
        GoTo hError
    Else
        Debug.Print "Successfully unbound from the Domain"
    End If
    
    GoTo hError
    
hError:
    
    GetReplData = lRet

End Function

Public Function PtrToStrW(lpStringW As Long) As String
    
    Dim buffer() As Byte
    Dim nLen As Long
   
    If lpStringW <> 0 Then
        nLen = lstrlenW(lpStringW) * 2
        If nLen Then
            ReDim buffer(0 To (nLen - 1)) As Byte
            Call MoveMemory(buffer(0), ByVal lpStringW, nLen)
            PtrToStrW = Trim(UCase(buffer))
        End If
    End If
    
End Function

Private Sub cmdCopy_Click()

    Dim i As Long
    Clipboard.Clear
    txtCopy.Text = ""
    For i = 0 To lstOutput.ListCount - 1
        txtCopy.Text = txtCopy.Text & lstOutput.List(i) & vbCrLf
    Next i
    Clipboard.SetText txtCopy

End Sub

Private Function GetStrGUID(lngGuid As GUID) As String

   GetStrGUID = Space$(GUID_LENGTH)
   Call StringFromGUID2(lngGuid, StrPtr(GetStrGUID), GUID_LENGTH + 1)
   GetStrGUID = Trim(Left(GetStrGUID, InStr(GetStrGUID, Chr(0)) - 1))

End Function


