VERSION 5.00
Begin VB.Form ReplSync 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "DsReplicaSync"
   ClientHeight    =   2715
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   6150
   Icon            =   "Chap09_Listing22_DS_Replica_Sync_form.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2715
   ScaleWidth      =   6150
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSync 
      Caption         =   "&Synchronize"
      Height          =   375
      Left            =   2280
      TabIndex        =   1
      Top             =   2280
      Width           =   1575
   End
   Begin VB.ListBox lstOutput 
      Height          =   2205
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   6135
   End
End
Attribute VB_Name = "ReplSync"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit
Option Base 0

' -----------------------------------------------------------------------------
' From the book "Managing Enterprise Active Directory Services"
' ISBN: 0-672-32125-4
' Copyright (C) 2002 by Addison-Wesley
' Code by Richard Puckett
'
' You have a royalty-free right to use, modify, reproduce and distribute
' this code (and/or any modified version) in any way you find useful,
' with the agreement that Richard Puckett or Addison-Wesley provide no
' warranty, obligations or liability for this code. If you reuse or
' modify this code, you must retain this copyright notice.
' -----------------------------------------------------------------------------

Private Const GUID_LENGTH As Long = 40

'// Perform this operation asynchronously.
'// Required when using DS_REPSYNC_ALL_SOURCES
'#define DS_REPSYNC_ASYNCHRONOUS_OPERATION 0x00000001

Private Const DS_REPSYNC_ASYNCHRONOUS_OPERATION = &H1

'// Writeable replica.  Otherwise, read-only.
'#define DS_REPSYNC_WRITEABLE              0x00000002
'// This is a periodic sync request as scheduled by the admin.
'#define DS_REPSYNC_PERIODIC               0x00000004
'// Use inter-site messaging
'#define DS_REPSYNC_INTERSITE_MESSAGING    0x00000008
'// Sync from all sources.
'#define DS_REPSYNC_ALL_SOURCES            0x00000010
'// Sync starting from scratch (i.e., at the first USN).
'#define DS_REPSYNC_FULL                   0x00000020
'// This is a notification of an update that was marked urgent.
'#define DS_REPSYNC_URGENT                 0x00000040
'// Don't discard this synchronization request, even if a similar
'// sync is pending.
'#define DS_REPSYNC_NO_DISCARD             0x00000080
'// Sync even if link is currently disabled.
'#define DS_REPSYNC_FORCE                  0x00000100
'// Causes the source DSA to check if a reps-to is present for the local DSA
'// (aka the destination). If not, one is added.  This ensures that
'// source sends change notifications.
'#define DS_REPSYNC_ADD_REFERENCE          0x00000200
'// A sync from this source has never completed (e.g., a new source).
'#define DS_REPSYNC_NEVER_COMPLETED        0x00000400
'// When this sync is complete, requests a sync in the opposite direction.
'#define DS_REPSYNC_TWO_WAY                0x00000800
'// Do not request change notifications from this source.
'#define DS_REPSYNC_NEVER_NOTIFY           0x00001000
'// Sync the NC from this source when the DSA is started.
'#define DS_REPSYNC_INITIAL                0x00002000
'// Use compression when replicating.  Saves message size (e.g., network
'// bandwidth) at the expense of extra CPU overhead at both the source and
'// destination servers.
'#define DS_REPSYNC_USE_COMPRESSION        0x00004000
'// Sync was abandoned for lack of updates
'#define DS_REPSYNC_ABANDONED              0x00008000
'// Initial sync in progress
'#define DS_REPSYNC_INITIAL_IN_PROGRESS    0x00010000
'// Partial Attribute Set sync in progress
'#define DS_REPSYNC_PARTIAL_ATTRIBUTE_SET  0x00020000
'// Sync is being retried
'#define DS_REPSYNC_REQUEUE                0x00040000
'// Sync is a notification request from a source
'#define DS_REPSYNC_NOTIFICATION           0x00080000
'// Sync is a special form which requests to establish contact
'// now and do the rest of the sync later
'#define DS_REPSYNC_ASYNCHRONOUS_REPLICA   0x00100000
'// Request critical objects only
'#define DS_REPSYNC_CRITICAL               0x00200000
'// A full synchronization is in progress
'#define DS_REPSYNC_FULL_IN_PROGRESS       0x00400000
'// Synchronization request was previously preempted
'#define DS_REPSYNC_PREEMPTED              0x00800000

'typedef struct _GUID{
'  unsigned long  Data1;
'  unsigned short Data2;
'  unsigned short Data3;
'  unsigned char  Data4[8];
'} GUID;
'typedef GUID UUID;

Private Type GUID
   Data1 As Long
   Data2 As Integer
   Data3 As Integer
   Data4(0 To 7) As Byte
End Type


Private Declare Function CLSIDFromString Lib "ole32.dll" _
    (pStrGuid As Long, _
    pUdtGuid As GUID) As Long

Private Declare Function StringFromGUID2 Lib "ole32.dll" _
    (pGuid As GUID, _
    ByVal PointerToString As Long, _
    ByVal MaxLength As Long) As Long

'DWORD DsReplicaSync(
'  HANDLE hDS,
'  LPCTSTR NameContext,
'  const UUID* pUuidDsaSrc,
'  ULONG Options
');

Private Declare Function DsReplicaSync Lib "ntdsapi.dll" _
    Alias "DsReplicaSyncW" _
    (ByVal hDS As Long, _
    ByVal NameContext As Long, _
    pUuid As GUID, _
    ByVal pOptions As Long) As Long

Private Declare Function DsMakePasswordCredentials Lib "ntdsapi.dll" _
    Alias "DsMakePasswordCredentialsA" _
    (ByVal User As String, _
    ByVal Domain As String, _
    ByVal Password As String, _
    pAuthIdentity As Long) As Long

Private Declare Function DsBindWithCred Lib "ntdsapi.dll" _
    Alias "DsBindWithCredA" _
    (ByVal DomainController As String, _
    ByVal DnsDomainName As String, _
    ByVal AuthIdentity As Long, _
    phDS As Long) As Long
    
Private Declare Function DsFreePasswordCredentials Lib "ntdsapi.dll" _
    (ByVal AuthIdentity As Long) As Long
    
Private Declare Function DsBind Lib "ntdsapi.dll" _
    Alias "DsBindA" _
    (ByVal DomainController As String, _
    ByVal DnsDomainName As String, _
    phDS As Long) As Long
    
Private Declare Function DsUnBind Lib "ntdsapi.dll" _
    Alias "DsUnBindA" _
    (ByVal phDS As Long) As Long

Private Sub Form_Load()

End Sub

Private Sub cmdSync_Click()

    Dim lngRet As Long
    Dim Userid As String
    Dim Passwd As String
    Dim Domain As String
    Dim strUid As String
    Dim strDN As String
    Dim ADC As String
    
    Userid = "userid"
    Passwd = "password"
    Domain = "XYZ"
    strUid = "{a9ee315b-ac56-4581-ba62-a69c73eed2c0}"
    ADC = "adc-xyz-201.amer.xyz.com"
    strDN = "CN=Configuration,DC=xyz,DC=com"
   
    lngRet = SyncReplicas(Userid, _
             Passwd, _
             Domain, _
             ADC, _
             strUid, _
             strDN)
    
    If lngRet <> 0 Then
        MsgBox "Error " & lngRet
    Else
        MsgBox "Success!"
    End If
    
End Sub

Private Function SyncReplicas(strUserid As String, strPasswd As String, _
    strDomain As String, strDC As String, strUuid As String, strDName As String) As Long

    Dim lRet As Long
    Dim hDS As Long
    Dim hCred As Long
    Dim strADC As String
    Dim pUuid As GUID
    
    strADC = "\\" & strDC & Chr(0)
    
    ' Create a credential handle
    lRet = DsMakePasswordCredentials(strUserid, _
           strDomain, _
           strPasswd, _
           hCred)

    If lRet <> 0 Then
        lstOutput.AddItem "Error " & lRet & " creating a credential handle for " & _
        strDomain & "\" & strUserid
        GoTo hError
    Else
        lstOutput.AddItem "Successfully created a credential handle for " & _
        strDomain & "\" & strUserid
    End If
    
    ' Bind to a Domain Controller
    lRet = DsBindWithCred(strADC, _
           vbNullString, _
           hCred, _
           hDS)
    
    If lRet <> 0 Then
        lstOutput.AddItem "Error " & lRet & " binding to " & _
        strDC & " with the credential handle"
        GoTo hError
    Else
        lstOutput.AddItem "Successfully bound to " & _
        strDC & " with the credential handle"
    End If
        
    ' Convert String UUID to Binary UUID
    pUuid = GuidFromString(strUuid)
        
    lstOutput.AddItem "Confirm UUID: " & GetStrGUID(pUuid)
                
    ' Call DsReplicaSync Asynchronously
    lRet = DsReplicaSync(hDS, _
           StrPtr(strDName), _
           pUuid, _
           DS_REPSYNC_ASYNCHRONOUS_OPERATION)
    
    If lRet <> 0 Then
        lstOutput.AddItem "Error " & lRet & _
        " unable to sync destination with source: " & strUuid
        GoTo hError
    Else
        lstOutput.AddItem "Successfully synched the destination with source: " & strUuid
    End If

    ' Free the passed in Credentials
    lRet = DsFreePasswordCredentials(hCred)
    
    If lRet <> 0 Then
        lstOutput.AddItem "Error " & lRet & " freeing the credential handle"
        GoTo hError
    Else
        lstOutput.AddItem "Successfully freed the credential handle"
    End If
    
    ' Unbind from the server
    lRet = DsUnBind(hDS)
    
    If lRet <> 0 Then
        lstOutput.AddItem "Error " & lRet & " unbinding from the Domain"
        GoTo hError
    Else
        lstOutput.AddItem "Successfully unbound from the Domain"
    End If
    
    GoTo hError
    
hError:
    
    SyncReplicas = lRet

End Function

Private Function GuidFromString(strGuid As String) As GUID

    Call CLSIDFromString(ByVal StrPtr(strGuid), GuidFromString)
    
End Function

Private Function GetStrGUID(lngGuid As GUID) As String

   GetStrGUID = Space$(GUID_LENGTH)
   Call StringFromGUID2(lngGuid, StrPtr(GetStrGUID), GUID_LENGTH + 1)
   GetStrGUID = Trim(Left(GetStrGUID, InStr(GetStrGUID, Chr(0)) - 1))

End Function

Private Sub lstOutput_Click()

End Sub
