'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim user, passwd, server, absSchemaObj, classObj, ldapObj

server = "dc1"
user   = "administrator@xyz.com"
passwd = "password"

Set ldapObj = GetObject("LDAP:")
Set absSchemaObj = ldapObj.OpenDsObject("LDAP://" & server & "/Schema", _
                                        user, passwd, 1)
absSchemaObj.Filter = Array("Class")
For Each classO in absSchemaObj
 if classObj.Abstract = TRUE Then
   Wscript.Echo classObj.name
   If IsArray(classObj.PossibleSuperiors) = TRUE Then
      For Each possSup in classObj.PossibleSuperiors
        Wscript.Echo " " & possSup
      Next
   Else
        Wscript.Echo " " & classObj.PossibleSuperiors
   End If
 End If
Next
