# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use Data::UUID;

# Get a GUID object
my $guid = Data::UUID->new();

# Create a new binary GUID
my $bin_guid = $guid->create();

# Base64 encode
my $b64_guid = $guid->to_b64string($bin_guid);

print "$b64_guid\n";
