'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
ON ERROR RESUME NEXT
Dim strUser, strPasswd, new_user
strUser   = "administrator@xyz.com"
strPasswd = "password"

new_user = "user1"

Dim ldapObj, contADsPath, contObj
Set ldapObj = GetObject("LDAP:")
contADsPath = "LDAP://cn=Users,dc=xyz,dc=com"
Set contObj = ldapObj.OpenDsObject(contADsPath,strUser,strPasswd,1)
Set usrObj = contObj.Create("user","cn=" & new_user)
usrObj.Put "sAMAccountName",new_user
usrObj.SetInfo
If Err.Number Then
   Wscript.Echo "Error occurred creating user: " & Err.Description
Else
   Wscript.Echo "User created"
End If
