'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim strUser, strPasswd, strServer
strServer = "dc1"
strUser   = "administrator@xyz.com"
strPasswd = "password"

Dim ldapObj, groupADsPath, groupObj
Set ldapObj = GetObject("LDAP:")

groupADsPath = "LDAP://cn=Administrators,cn=Builtin,dc=xyz,dc=com"
Set grpObj = ldapObj.OpenDsObject(groupADsPath,strUser,strPasswd,1)

grpObj.Add("LDAP://CN=janesmith,cn=Users,dc=xyz,dc=com")
Wscript.Echo "Added Jane Smith to Administrators"

' Remove Jim Smith from Administrators
grpObj.Remove("LDAP://CN=jimsmith,cn=Users,dc=xyz,dc=com")
Wscript.Echo "Remove Jim Smith from Administrators"
