
# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Code by Richard Puckett
#
# You have a royalty-free right to use, modify, reproduce and distribute
# this code (and/or any modified version) in any way you find useful,
# with the agreement that Richard Puckett or Addison-Wesley provide no
# warranty, obligations or liability for this code. If you reuse or
# modify this code, you must retain this copyright notice.
# -----------------------------------------------------------------------------
        
#! c:\perl\bin\perl.exe -w

use strict; 
use Win32::OLE qw(in); 

my $strQuery = "SELECT * FROM Win32_Group WHERE Sid = 'S-1-5-32-544' AND Domain = 'Builtin'";

my $Wmi = Win32::OLE->GetObject("winmgmts:");
my $Group = $Wmi->ExecQuery($strQuery);

foreach my $Name(in $Group) {
		my $adm = $Name->Name;
		print "S-1-5-32-544 is named: ".$adm."\n";
}
