
# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Code by Richard Puckett
#
# You have a royalty-free right to use, modify, reproduce and distribute
# this code (and/or any modified version) in any way you find useful,
# with the agreement that Richard Puckett or Addison-Wesley provide no
# warranty, obligations or liability for this code. If you reuse or
# modify this code, you must retain this copyright notice.
# -----------------------------------------------------------------------------
        
#! c:\perl\bin\perl.exe -w

use strict;
use Win32::API;
use constant RP_FORCE => 0x1;

my $RefreshPolicy = new Win32::API('USERENV', 
   'RefreshPolicy', 
   ['N', 'N'], 'N');

#first value can be 0 (Computer Policy) or 1 (User Policy)
my $lret = $RefreshPolicy->Call(0, RP_FORCE) 
	or die "Error $^E: Could not refresh Policy\n";

