VERSION 5.00
Begin VB.Form GPOList 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Get Applied GPOs"
   ClientHeight    =   4905
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5175
   Icon            =   "Chap13_Listing07_Get_Applied_Gpos_form.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4905
   ScaleWidth      =   5175
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtCopy 
      Height          =   375
      Left            =   4440
      TabIndex        =   10
      Top             =   4440
      Visible         =   0   'False
      Width           =   495
   End
   Begin VB.CommandButton cmdCopy 
      Caption         =   "&Copy to Clipboard"
      Height          =   375
      Left            =   2640
      TabIndex        =   9
      Top             =   4440
      Width           =   1575
   End
   Begin VB.CommandButton cmdGetGPOs 
      Caption         =   "&Get GPOs"
      Default         =   -1  'True
      Height          =   375
      Left            =   960
      TabIndex        =   5
      Top             =   4440
      Width           =   1575
   End
   Begin VB.Frame Frame2 
      Caption         =   "Server && Policy Type"
      Height          =   1335
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   5175
      Begin VB.ComboBox cmbPolType 
         Height          =   315
         Left            =   1680
         Style           =   2  'Dropdown List
         TabIndex        =   4
         Top             =   840
         Width           =   3015
      End
      Begin VB.TextBox txtSrv 
         Height          =   285
         Left            =   1680
         TabIndex        =   3
         Top             =   280
         Width           =   3015
      End
      Begin VB.Label Label3 
         Alignment       =   2  'Center
         Caption         =   "* (leave system name blank for localhost)"
         Height          =   255
         Left            =   1560
         TabIndex        =   8
         Top             =   600
         Width           =   3135
      End
      Begin VB.Label Label2 
         Caption         =   "Policy Type:"
         Height          =   255
         Left            =   600
         TabIndex        =   7
         Top             =   840
         Width           =   975
      End
      Begin VB.Label Label1 
         Caption         =   "System Name:"
         Height          =   255
         Left            =   480
         TabIndex        =   6
         Top             =   360
         Width           =   1095
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Output"
      Height          =   3015
      Left            =   0
      TabIndex        =   0
      Top             =   1320
      Width           =   5175
      Begin VB.ListBox lstOutput 
         Height          =   2595
         ItemData        =   "Chap13_Listing07_Get_Applied_Gpos_form.frx":030A
         Left            =   120
         List            =   "Chap13_Listing07_Get_Applied_Gpos_form.frx":030C
         TabIndex        =   1
         Top             =   240
         Width           =   4935
      End
   End
End
Attribute VB_Name = "GPOList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

' -----------------------------------------------------------------------------
' From the book "Managing Enterprise Active Directory Services"
' ISBN: 0-672-32125-4
' Copyright (C) 2002 by Addison-Wesley
' Code by Richard Puckett
'
' You have a royalty-free right to use, modify, reproduce and distribute
' this code (and/or any modified version) in any way you find useful,
' with the agreement that Richard Puckett or Addison-Wesley provide no
' warranty, obligations or liability for this code. If you reuse or
' modify this code, you must retain this copyright notice.
' -----------------------------------------------------------------------------

Private Const GPO_LIST_FLAG_MACHINE = &H1
Private Const GPO_LIST_FLAG_SITEONLY = &H2
Private Const GPO_FLAG_DISABLE = &H1
Private Const GPO_FLAG_FORCE = &H2
Private Const GUID_LENGTH As Long = 38

'#define GPO_FLAG_DISABLE               0x00000001  // This GPO is disabled
'#define GPO_FLAG_FORCE                 0x00000002  // Don't override the settings in
'#define GPO_FLAG_DISABLE               0x00000001  // This GPO is disabled
'#define GPO_FLAG_FORCE                 0x00000002
'#define GPO_LIST_FLAG_MACHINE          0x00000001  // Return machine policy information
'#define GPO_LIST_FLAG_SITEONLY         0x00000002  // Return site policy information only
'#define GPO_INFO_FLAG_MACHINE          0x00000001  // Apply machine policy rather than user policy
'#define GPO_INFO_FLAG_BACKGROUND       0x00000010  // Background refresh of policy (ok to do slow stuff)
'#define GPO_INFO_FLAG_SLOWLINK         0x00000020  // Policy is being applied across a slow link
'#define GPO_INFO_FLAG_VERBOSE          0x00000040  // Verbose output to the eventlog
'#define GPO_INFO_FLAG_NOCHANGES        0x00000080  // No changes were detected to the Group Policy Objects
'#define GPO_INFO_FLAG_LINKTRANSITION   0x00000100  // A change in link speed was detected between previous policy
'                                                   // application and current policy application
'
'#define REGISTRY_EXTENSION_GUID  { 0x35378EAC, 0x683F, 0x11D2, 0xA8, 0x9A, 0x00, 0xC0, 0x4F, 0xBB, 0xCF, 0xA2 }
'
        
'BOOL FreeGPOList(
'  PGROUP_POLICY_OBJECT *pGPOList
');

'BOOL GetAppliedGPOList(
'  DWORD dwFlags,
'  LPCTSTR pMachineName,
'  PSID pSidUser,
'  GUID *pGuidExtension,
'  PGROUP_POLICY_OBJECT *ppGPOList
');

'typedef enum _GPO_LINK {
'    GPLinkUnknown = 0,                     // No link information available
'    GPLinkMachine,                         // GPO linked to a machine (local or remote)
'    GPLinkSite,                            // GPO linked to a site
'    GPLinkDomain,                          // GPO linked to a domain
'    GPLinkOrganizationalUnit               // GPO linked to a organizational unit
'} GPO_LINK, *PGPO_LINK;

'typedef struct _GROUP_POLICY_OBJECT {
'  DWORD    dwOptions;
'  DWORD    dwVersion;
'  LPCTSTR  lpDSPath;
'  LPCTSTR  lpFileSysPath;
'  LPCTSTR  lpDisplayName;
'  TCHAR    szGPOName[50];
'  GPO_LINK GPOLink;
'  LPARAM   lParam;
'  struct   _GROUP_POLICY_OBJECT *pNext;
'  struct   _GROUP_POLICY_OBJECT *pPrev;
'  LPTSTR   lpExtensions;
'  LPARAM   lParam2;
'  LPTSTR   lpLink;
'}  GROUP_POLICY_OBJECT, *PGROUP_POLICY_OBJECT;

Private Type GROUP_POLICY_OBJECT
    dwOptions As Long
    dwVersion As Long
    lpDSPath As Long
    lpFileSysPath As Long
    lpDisplayName As Long
    szGPOName As String * 50
    GPOLink As Long
    lParam As Long
    pNext As Long
    pPref As Long
    lpExtensions As Long
    lParam2 As Long
    lpLink As Long
End Type

Private Type GUID
   Data1 As Long
   Data2 As Integer
   Data3 As Integer
   Data4(0 To 7) As Byte
End Type
     
Private Declare Function lstrlenA Lib "kernel32" _
    (ByVal lpString As Long) As Long

Private Declare Function lstrcpyA Lib "kernel32" _
    (ByVal szDest As String, _
    ByVal lpSource As Long) As Long

Private Declare Function CLSIDFromString Lib "ole32.dll" _
    (pStrGuid As Long, _
    pUdtGuid As GUID) As Long
      
Private Declare Function GetAppliedGPOList Lib "Userenv.dll" _
    Alias "GetAppliedGPOListA" _
    (ByVal dwFlags As Long, _
    ByVal pMachineName As String, _
    ByVal pSid As Long, _
    pGuid As GUID, _
    ppGPOList As Long) As Long
        
Private Declare Sub MoveMemory Lib "kernel32" _
    Alias "RtlMoveMemory" _
    (pDest As Any, _
    pSource As Any, _
    ByVal dwLength As Long)
        
Private Declare Function FreeGPOList Lib "Userenv.dll" _
        Alias "FreeGPOListA" _
        (ByVal pGPOList As Long) As Boolean

Private Sub Form_Load()

    cmbPolType.AddItem "Disk Quota policy"
    cmbPolType.AddItem "EFS Recovery policy"
    cmbPolType.AddItem "Folder Redirection policy"
    cmbPolType.AddItem "Internet Explorer Maintenance policy"
    cmbPolType.AddItem "IP Security policy"
    cmbPolType.AddItem "Registry policy"
    cmbPolType.AddItem "Scripts policy"
    cmbPolType.AddItem "Security policy"
    cmbPolType.AddItem "Software Installation policy"
    
    '{25537BA6-77A8-11D2-9B6C-0000F8080861}  Folder Redirection policy
    '{35378EAC-683F-11D2-A89A-00C04FBBCFA2}  Registry policy
    '{3610EDA5-77EF-11D2-8DC5-00C04FA31A66}  Disk Quota policy
    '{42B5FAAE-6536-11D2-AE5A-0000F87571E3}  Scripts policy
    '{827D319E-6EAC-11D2-A4EA-00C04F79F83A}  Security policy
    '{A2E30F80-D7DE-11d2-BBDE-00C04F86AE3B}  Internet Explorer Maintenance policy
    '{B1BE8D72-6EAC-11D2-A4EA-00C04F79F83A}  EFS Recovery policy
    '{C6DC5466-785A-11D2-84D0-00C04FB169f7}  Software Installation policy
    '{E437BC1C-AA7D-11D2-A382-00C04F991E27}  IP Security policy
    
End Sub

Private Sub cmdGetGPOs_Click()

    lstOutput.Clear
    Call GetAppliedGPOs(txtSrv.Text, cmbPolType.Text)

End Sub

Private Function GetAppliedGPOs(strMachineName As String, strPolType As String) As Long

    Dim lPtr As Long
    Dim mPtr As Long
    Dim lRet As Long
    Dim strSrv As String
    Dim strPolGuid As String
    Dim pGPOList As GROUP_POLICY_OBJECT
    Dim pGuid As GUID

    If LenB(strMachineName) > 0 Then
        strSrv = "\\" & strMachineName
    Else
        strSrv = vbNullString
    End If
    
    Select Case strPolType
        Case "Folder Redirection policy"
            strPolGuid = "{25537BA6-77A8-11D2-9B6C-0000F8080861}"
        Case "Registry policy"
            strPolGuid = "{35378EAC-683F-11D2-A89A-00C04FBBCFA2}"
        Case "Disk Quota policy"
            strPolGuid = "{3610EDA5-77EF-11D2-8DC5-00C04FA31A66}"
        Case "Scripts policy"
            strPolGuid = "{42B5FAAE-6536-11D2-AE5A-0000F87571E3}"
        Case "Security policy"
            strPolGuid = "{827D319E-6EAC-11D2-A4EA-00C04F79F83A}"
        Case "Internet Explorer Maintenance policy"
            strPolGuid = "{A2E30F80-D7DE-11d2-BBDE-00C04F86AE3B}"
        Case "EFS Recovery policy"
            strPolGuid = "{B1BE8D72-6EAC-11D2-A4EA-00C04F79F83A}"
        Case "Software Installation policy"
            strPolGuid = "{C6DC5466-785A-11D2-84D0-00C04FB169f7}"
        Case "IP Security policy"
            strPolGuid = "{E437BC1C-AA7D-11D2-A382-00C04F991E27}"
        Case Else
            strPolGuid = "{827D319E-6EAC-11D2-A4EA-00C04F79F83A}"
    End Select

    pGuid = GuidFromString(strPolGuid)
                 
    lRet = GetAppliedGPOList(GPO_LIST_FLAG_MACHINE, _
           strSrv, _
           0&, _
           pGuid, _
           lPtr)
              
    If lRet = 0 Then
        mPtr = lPtr
        
        Do While lPtr <> 0
            MoveMemory pGPOList, ByVal lPtr, Len(pGPOList)
            With pGPOList
                lstOutput.AddItem "GPO Display Name: " & StrFromPtrA(.lpDisplayName)
                lstOutput.AddItem "------------------------------------------------------------------------------"
                lstOutput.AddItem "GPO Options: " & .dwOptions
                lstOutput.AddItem "GPO Version: " & .dwVersion
                lstOutput.AddItem "GPO DS Path: " & StrFromPtrA(.lpDSPath)
                lstOutput.AddItem "GPO File System Path: " & StrFromPtrA(.lpFileSysPath)

                lstOutput.AddItem "GPO Link: " & StrFromPtrA(.lpLink)
                lstOutput.AddItem "GPO Unique Name: " & .szGPOName
                Select Case .GPOLink
                    Case 0
                        lstOutput.AddItem "GPLinkUnknown: No link information is available."
                    Case 1
                        lstOutput.AddItem "GPLinkMachine: The GPO is linked to a computer (local or remote)."
                    Case 2
                        lstOutput.AddItem "GPLinkSite: The GPO is linked to a site."
                    Case 3
                        lstOutput.AddItem "GPLinkDomain: The GPO is linked to a domain."
                    Case 4
                        lstOutput.AddItem "GPLinkOrganizationalUnit: The GPO is linked to an organizational unit."
                    Case Else
                        lstOutput.AddItem "The GPO Link Type is unknown (" & .GPOLink & ")"
                End Select
                lstOutput.AddItem "GPO Param Data: " & StrFromPtrA(.lParam)
                lstOutput.AddItem "GPO Extensions: " & StrFromPtrA(.lpExtensions)
                lstOutput.AddItem "GPO Param Data 2: " & StrFromPtrA(.lParam2)
                lstOutput.AddItem ""
                lPtr = .pNext
            End With
            
            DoEvents
            
        Loop
    Else
        lstOutput.AddItem "Doh!: " & Err.LastDllError & "(" & lRet & ")"
    End If
    
    lRet = FreeGPOList(mPtr)
    

End Function

Private Function GuidFromString(strGuid As String) As GUID

    Call CLSIDFromString(ByVal StrPtr(strGuid), GuidFromString)
    
End Function

Public Function StrFromPtrA(lpStr As Long) As String

   StrFromPtrA = String(lstrlenA(ByVal lpStr), 0&)
   Call lstrcpyA(ByVal StrFromPtrA, ByVal lpStr)
   
End Function

Private Sub cmdCopy_Click()

    Dim i As Long
    Clipboard.Clear
    txtCopy.Text = ""
    For i = 0 To lstOutput.ListCount - 1
        txtCopy.Text = txtCopy.Text & lstOutput.List(i) & vbCrLf
    Next i
    Clipboard.SetText txtCopy

End Sub
