
# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Code by Richard Puckett
#
# You have a royalty-free right to use, modify, reproduce and distribute
# this code (and/or any modified version) in any way you find useful,
# with the agreement that Richard Puckett or Addison-Wesley provide no
# warranty, obligations or liability for this code. If you reuse or
# modify this code, you must retain this copyright notice.
# -----------------------------------------------------------------------------
        
#! c:\perl\bin\perl.exe -w

#HRESULT CreateGPOLink(
#  LPOLESTR lpGPO,
#  LPOLESTR lpContainer,
#  BOOL fHighPriority
#);

use strict;
use Win32::API;

my $CreateLink = new Win32::API('GPEDIT', 
   'CreateGPOLink', 
   ['P', 'P', 'N'], 'N');

my $gplink = "LDAP://OU=Employees,OU=XYZ Users,DC=xyz,DC=com"
my $gpo = "LDAP://CN=Machine,CN={31B2F340-016D-11D2-945F-00C04FB984F9},CN=Policies,CN=System,DC=xyz,DC=com"

my $lret = $CreateLink->Call($gpo, $gplink, TRUE) 
	or die "Error $^E: Could not create the policy link for $gplink\n";
